# coding=utf8

# Copyright 2018 JDCLOUD.COM
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# NOTE: This class is auto generated by the jdcloud code generator program.

from argparse import RawTextHelpFormatter
from jdcloud_cli.cement.ext.ext_argparse import expose
from jdcloud_cli.controllers.base_controller import BaseController
from jdcloud_cli.client_factory import ClientFactory
from jdcloud_cli.parameter_builder import collect_user_args, collect_user_headers
from jdcloud_cli.printer import Printer
from jdcloud_cli.skeleton import Skeleton


class OssopenapiController(BaseController):
    class Meta:
        label = 'ossopenapi'
        help = 'oss openapi'
        description = '''
        ossopenapi cli 子命令，oss openapi。
        OpenAPI文档地址为：https://docs.jdcloud.com/cn/xxx/api/overview
        '''
        stacked_on = 'base'
        stacked_type = 'nested'

    @expose(
        arguments=[
            (['--region-id'], dict(help="""(string) 区域ID """, dest='regionId',  required=False)),
            (['--bucket-name'], dict(help="""(string) 查询用量的指定bucket """, dest='bucketName',  required=True)),
            (['--capacity-types'], dict(help="""(array: int) <p>查询用量数据类型：</p><br><code>1000040</code>:标准存储<br><code>1000041</code>:低冗余存储<br><code>1000042</code>:归档存储<br><code>1000043</code>归档overHead存储:<br><code>1000044</code>低频存储:<br><code>1000045</code>低频overHead存储:<br><code>1</code>:内网GET流量<br><code>2</code>:内网HEAD流量<br><code>3</code>:内网PUT流量<br><code>4</code>:内网POST流量<br><code>5</code>:内网DELETE流量<br><code>6</code>:内网OPTIONS流量<br><code>7</code>:内网TRACE流量<br><code>11</code>:外网GET流量<br><code>12</code>:外网HEAD流量<br><code>13</code>:外网PUT流量<br><code>14</code>:外网POST流量<br><code>15</code>:外网DELETE流量<br><code>16</code>:外网OPTIONS流量<br><code>17</code>:外网TRACE流量<br><code>21</code>:CDN GET流量<br><code>22</code>:CDN HEAD流量<br><code>23</code>:CDN PUT流量<br><code>24</code>:CDN POST流量<br><code>25</code>:CDN DELETE流量<br><code>26</code>:CDN OPTIONS流量<br><code>27</code>:CDN TRACE流量<br><code>31</code>:内网GET数<br><code>32</code>:内网HEAD数<br><code>33</code>:内网PUT数<br><code>34</code>:内网POST数<br><code>35</code>:内网DELETE数<br><code>36</code>:内网OPTIONS数<br><code>37</code>:内网TRACE数<br><code>51</code>:外网GET数<br><code>52</code>:外网HEAD数<br><code>53</code>:外网PUT数<br><code>54</code>:外网POST数<br><code>55</code>:外网DELETE数<br><code>56</code>:外网OPTIONS数<br><code>57</code>:外网TRACE数<br><code>61</code>:CDN GET数<br><code>62</code>:CDN HEAD数<br><code>63</code>:CDN PUT数<br><code>64</code>:CDN POST数<br><code>65</code>:CDN DELETE数<br><code>66</code>:CDN OPTIONS数<br><code>67</code>:CDN TRACE数<br><code>71</code>:归档提前删除<br><code>72</code>:低频提前删除<br><code>81</code>:归档取回Bulk<br><code>82</code>:归档取回Std<br><code>83</code>:归档取回Exp<br><code>84</code>:低频数据取回;  """, dest='capacityTypes', type=int, required=True)),
            (['--begin-time'], dict(help="""(string) 开始时间，使用UTC时间，格式为：YYYY-MM-DDTHH:mm:ss'Z' """, dest='beginTime',  required=False)),
            (['--end-time'], dict(help="""(string) 结束时间，使用UTC时间，格式为：YYYY-MM-DDTHH:mm:ss'Z' """, dest='endTime',  required=False)),
            (['--period-type'], dict(help="""(int) 查询数据的聚合方式:<br><code>0</code>:all, 最大查询区间365天 <br><code>1</code>:hour，最大查询区间31天。默认1<br><code>2</code>:day, 最大查询区间365天。 """, dest='periodType', type=int, required=False)),
            (['--method'], dict(help="""(int) 返回数据的方式： <code>1</code>:recent(区间值), <code>2</code>:current(当前值。method = 2 时如果查询当前值时传入beginTime，则按照beginTime时间来进行查询；如果不传beginTime，则按照后端系统时间查询。) """, dest='method', type=int, required=True)),
            (['--input-json'], dict(help='(json) 以json字符串或文件绝对路径形式作为输入参数。\n字符串方式举例：--input-json \'{"field":"value"}\';\n文件格式举例：--input-json file:///xxxx.json', dest='input_json', required=False)),
            (['--jdcloud-header'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='jdcloudHeaders', required=False)),
            (['--headers'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='headers', required=False)),
        ],
        formatter_class=RawTextHelpFormatter,
        help=''' 根据type获取指定bucket用量数据 ''',
        description='''
            根据type获取指定bucket用量数据。

            示例: jdc ossopenapi get-single-bucket-capacity  --bucket-name xxx --capacity-types [5] --method 5
        ''',
    )
    def get_single_bucket_capacity(self):
        client_factory = ClientFactory('ossopenapi')
        client = client_factory.get(self.app)
        if client is None:
            return

        try:
            from jdcloud_sdk.services.ossopenapi.apis.GetSingleBucketCapacityRequest import GetSingleBucketCapacityRequest
            params_dict = collect_user_args(self.app)
            headers = collect_user_headers(self.app)
            req = GetSingleBucketCapacityRequest(params_dict, headers)
            resp = client.send(req)
            Printer.print_result(resp)
        except ImportError:
            print('{"error":"This api is not supported, please use the newer version"}')
        except Exception as e:
            print(e)

    @expose(
        arguments=[
            (['--region-id'], dict(help="""(string) 区域ID """, dest='regionId',  required=False)),
            (['--bucket-name'], dict(help="""(string) Bucket名称 """, dest='bucketName',  required=True)),
            (['--input-json'], dict(help='(json) 以json字符串或文件绝对路径形式作为输入参数。\n字符串方式举例：--input-json \'{"field":"value"}\';\n文件格式举例：--input-json file:///xxxx.json', dest='input_json', required=False)),
            (['--jdcloud-header'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='jdcloudHeaders', required=False)),
            (['--headers'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='headers', required=False)),
        ],
        formatter_class=RawTextHelpFormatter,
        help=''' 获取回源配置 ''',
        description='''
            获取回源配置。

            示例: jdc ossopenapi get-back-source-configuration  --bucket-name xxx
        ''',
    )
    def get_back_source_configuration(self):
        client_factory = ClientFactory('ossopenapi')
        client = client_factory.get(self.app)
        if client is None:
            return

        try:
            from jdcloud_sdk.services.ossopenapi.apis.GetBackSourceConfigurationRequest import GetBackSourceConfigurationRequest
            params_dict = collect_user_args(self.app)
            headers = collect_user_headers(self.app)
            req = GetBackSourceConfigurationRequest(params_dict, headers)
            resp = client.send(req)
            Printer.print_result(resp)
        except ImportError:
            print('{"error":"This api is not supported, please use the newer version"}')
        except Exception as e:
            print(e)

    @expose(
        arguments=[
            (['--region-id'], dict(help="""(string) 区域ID """, dest='regionId',  required=False)),
            (['--bucket-name'], dict(help="""(string) Bucket名称 """, dest='bucketName',  required=True)),
            (['--back-source-rules'], dict(help="""(array: backSourceRule) 回源配置规则 """, dest='backSourceRules',  required=False)),
            (['--input-json'], dict(help='(json) 以json字符串或文件绝对路径形式作为输入参数。\n字符串方式举例：--input-json \'{"field":"value"}\';\n文件格式举例：--input-json file:///xxxx.json', dest='input_json', required=False)),
            (['--jdcloud-header'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='jdcloudHeaders', required=False)),
            (['--headers'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='headers', required=False)),
        ],
        formatter_class=RawTextHelpFormatter,
        help=''' 添加修改回源配置 ''',
        description='''
            添加修改回源配置。

            示例: jdc ossopenapi put-back-source-configuration  --bucket-name xxx
        ''',
    )
    def put_back_source_configuration(self):
        client_factory = ClientFactory('ossopenapi')
        client = client_factory.get(self.app)
        if client is None:
            return

        try:
            from jdcloud_sdk.services.ossopenapi.apis.PutBackSourceConfigurationRequest import PutBackSourceConfigurationRequest
            params_dict = collect_user_args(self.app)
            headers = collect_user_headers(self.app)
            req = PutBackSourceConfigurationRequest(params_dict, headers)
            resp = client.send(req)
            Printer.print_result(resp)
        except ImportError:
            print('{"error":"This api is not supported, please use the newer version"}')
        except Exception as e:
            print(e)

    @expose(
        arguments=[
            (['--region-id'], dict(help="""(string) 区域ID """, dest='regionId',  required=False)),
            (['--bucket-name'], dict(help="""(string) Bucket名称 """, dest='bucketName',  required=True)),
            (['--input-json'], dict(help='(json) 以json字符串或文件绝对路径形式作为输入参数。\n字符串方式举例：--input-json \'{"field":"value"}\';\n文件格式举例：--input-json file:///xxxx.json', dest='input_json', required=False)),
            (['--jdcloud-header'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='jdcloudHeaders', required=False)),
            (['--headers'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='headers', required=False)),
        ],
        formatter_class=RawTextHelpFormatter,
        help=''' 删除回源配置 ''',
        description='''
            删除回源配置。

            示例: jdc ossopenapi delete-back-source-configuration  --bucket-name xxx
        ''',
    )
    def delete_back_source_configuration(self):
        client_factory = ClientFactory('ossopenapi')
        client = client_factory.get(self.app)
        if client is None:
            return

        try:
            from jdcloud_sdk.services.ossopenapi.apis.DeleteBackSourceConfigurationRequest import DeleteBackSourceConfigurationRequest
            params_dict = collect_user_args(self.app)
            headers = collect_user_headers(self.app)
            req = DeleteBackSourceConfigurationRequest(params_dict, headers)
            resp = client.send(req)
            Printer.print_result(resp)
        except ImportError:
            print('{"error":"This api is not supported, please use the newer version"}')
        except Exception as e:
            print(e)

    @expose(
        arguments=[
            (['--region-id'], dict(help="""(string) 区域ID """, dest='regionId',  required=False)),
            (['--bucket-name'], dict(help="""(string) Bucket名称 """, dest='bucketName',  required=True)),
            (['--task-id'], dict(help="""(string) 任务ID """, dest='taskId',  required=True)),
            (['--input-json'], dict(help='(json) 以json字符串或文件绝对路径形式作为输入参数。\n字符串方式举例：--input-json \'{"field":"value"}\';\n文件格式举例：--input-json file:///xxxx.json', dest='input_json', required=False)),
            (['--jdcloud-header'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='jdcloudHeaders', required=False)),
            (['--headers'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='headers', required=False)),
        ],
        formatter_class=RawTextHelpFormatter,
        help=''' 根据bucket名称获取该bucket下的同步任务 ''',
        description='''
            根据bucket名称获取该bucket下的同步任务。

            示例: jdc ossopenapi get-historical-replicat-task  --bucket-name xxx --task-id xxx
        ''',
    )
    def get_historical_replicat_task(self):
        client_factory = ClientFactory('ossopenapi')
        client = client_factory.get(self.app)
        if client is None:
            return

        try:
            from jdcloud_sdk.services.ossopenapi.apis.GetHistoricalReplicatTaskRequest import GetHistoricalReplicatTaskRequest
            params_dict = collect_user_args(self.app)
            headers = collect_user_headers(self.app)
            req = GetHistoricalReplicatTaskRequest(params_dict, headers)
            resp = client.send(req)
            Printer.print_result(resp)
        except ImportError:
            print('{"error":"This api is not supported, please use the newer version"}')
        except Exception as e:
            print(e)

    @expose(
        arguments=[
            (['--region-id'], dict(help="""(string) 区域ID """, dest='regionId',  required=False)),
            (['--bucket-name'], dict(help="""(string) Bucket名称 """, dest='bucketName',  required=True)),
            (['--task-id'], dict(help="""(string) 任务ID """, dest='taskId',  required=True)),
            (['--input-json'], dict(help='(json) 以json字符串或文件绝对路径形式作为输入参数。\n字符串方式举例：--input-json \'{"field":"value"}\';\n文件格式举例：--input-json file:///xxxx.json', dest='input_json', required=False)),
            (['--jdcloud-header'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='jdcloudHeaders', required=False)),
            (['--headers'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='headers', required=False)),
        ],
        formatter_class=RawTextHelpFormatter,
        help=''' 停止bucket名称获取该bucket下的同步任务 ''',
        description='''
            停止bucket名称获取该bucket下的同步任务。

            示例: jdc ossopenapi abort-historical-replicat-task  --bucket-name xxx --task-id xxx
        ''',
    )
    def abort_historical_replicat_task(self):
        client_factory = ClientFactory('ossopenapi')
        client = client_factory.get(self.app)
        if client is None:
            return

        try:
            from jdcloud_sdk.services.ossopenapi.apis.AbortHistoricalReplicatTaskRequest import AbortHistoricalReplicatTaskRequest
            params_dict = collect_user_args(self.app)
            headers = collect_user_headers(self.app)
            req = AbortHistoricalReplicatTaskRequest(params_dict, headers)
            resp = client.send(req)
            Printer.print_result(resp)
        except ImportError:
            print('{"error":"This api is not supported, please use the newer version"}')
        except Exception as e:
            print(e)

    @expose(
        arguments=[
            (['--region-id'], dict(help="""(string) 区域ID """, dest='regionId',  required=False)),
            (['--bucket-name'], dict(help="""(string) Bucket名称 """, dest='bucketName',  required=True)),
            (['--marker'], dict(help="""(string) 同步任务列表开始的key """, dest='marker',  required=False)),
            (['--limit'], dict(help="""(int) 每次查询返回的结果数，默认为1000 """, dest='limit', type=int, required=False)),
            (['--input-json'], dict(help='(json) 以json字符串或文件绝对路径形式作为输入参数。\n字符串方式举例：--input-json \'{"field":"value"}\';\n文件格式举例：--input-json file:///xxxx.json', dest='input_json', required=False)),
            (['--jdcloud-header'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='jdcloudHeaders', required=False)),
            (['--headers'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='headers', required=False)),
        ],
        formatter_class=RawTextHelpFormatter,
        help=''' 根据bucket名称获取该bucket下的同步任务列表 ''',
        description='''
            根据bucket名称获取该bucket下的同步任务列表。

            示例: jdc ossopenapi list-historical-replicat-tasks  --bucket-name xxx
        ''',
    )
    def list_historical_replicat_tasks(self):
        client_factory = ClientFactory('ossopenapi')
        client = client_factory.get(self.app)
        if client is None:
            return

        try:
            from jdcloud_sdk.services.ossopenapi.apis.ListHistoricalReplicatTasksRequest import ListHistoricalReplicatTasksRequest
            params_dict = collect_user_args(self.app)
            headers = collect_user_headers(self.app)
            req = ListHistoricalReplicatTasksRequest(params_dict, headers)
            resp = client.send(req)
            Printer.print_result(resp)
        except ImportError:
            print('{"error":"This api is not supported, please use the newer version"}')
        except Exception as e:
            print(e)

    @expose(
        arguments=[
            (['--region-id'], dict(help="""(string) 区域ID """, dest='regionId',  required=False)),
            (['--bucket-name'], dict(help="""(string) Bucket名称 """, dest='bucketName',  required=True)),
            (['--action'], dict(help="""(string) 是否覆盖 """, dest='action',  required=True)),
            (['--bucket-region'], dict(help="""(string) bucket所属区域 """, dest='bucketRegion',  required=True)),
            (['--target-bucket-name'], dict(help="""(string) 目标bucket名称 """, dest='targetBucketName',  required=True)),
            (['--target-bucket-region'], dict(help="""(string) 目标bucket所属区域 """, dest='targetBucketRegion',  required=True)),
            (['--storage-class'], dict(help="""(string) 存储类型 """, dest='storageClass',  required=True)),
            (['--prefix-set'], dict(help="""(array: string) NA """, dest='prefixSet',  required=False)),
            (['--input-json'], dict(help='(json) 以json字符串或文件绝对路径形式作为输入参数。\n字符串方式举例：--input-json \'{"field":"value"}\';\n文件格式举例：--input-json file:///xxxx.json', dest='input_json', required=False)),
            (['--jdcloud-header'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='jdcloudHeaders', required=False)),
            (['--headers'], dict(help="""(json) 用户自定义Header，举例：'{"x-jdcloud-security-token":"abc","test":"123"}'""", dest='headers', required=False)),
        ],
        formatter_class=RawTextHelpFormatter,
        help=''' 创建历史同步任务 ''',
        description='''
            创建历史同步任务。

            示例: jdc ossopenapi create-historical-replicat-task  --bucket-name xxx --action xxx --bucket-region xxx --target-bucket-name xxx --target-bucket-region xxx --storage-class xxx
        ''',
    )
    def create_historical_replicat_task(self):
        client_factory = ClientFactory('ossopenapi')
        client = client_factory.get(self.app)
        if client is None:
            return

        try:
            from jdcloud_sdk.services.ossopenapi.apis.CreateHistoricalReplicatTaskRequest import CreateHistoricalReplicatTaskRequest
            params_dict = collect_user_args(self.app)
            headers = collect_user_headers(self.app)
            req = CreateHistoricalReplicatTaskRequest(params_dict, headers)
            resp = client.send(req)
            Printer.print_result(resp)
        except ImportError:
            print('{"error":"This api is not supported, please use the newer version"}')
        except Exception as e:
            print(e)

    @expose(
        arguments=[
            (['--api'], dict(help="""(string) api name """, choices=['get-single-bucket-capacity','get-back-source-configuration','put-back-source-configuration','delete-back-source-configuration','get-historical-replicat-task','abort-historical-replicat-task','list-historical-replicat-tasks','create-historical-replicat-task',], required=True)),
        ],
        formatter_class=RawTextHelpFormatter,
        help=''' 生成单个API接口的json骨架空字符串 ''',
        description='''
            生成单个API接口的json骨架空字符串。

            示例: jdc nc generate-skeleton --api describeContainer ''',
    )
    def generate_skeleton(self):
        skeleton = Skeleton('ossopenapi', self.app.pargs.api)
        skeleton.show()
